package com.njcn.energy.controller;

import com.njcn.common.pojo.annotation.OperateInfo;
import com.njcn.common.pojo.enums.common.LogEnum;
import com.njcn.common.pojo.enums.response.CommonResponseEnum;
import com.njcn.common.pojo.response.HttpResult;
import com.njcn.common.utils.HttpResultUtil;
import com.njcn.common.utils.LogUtil;
import com.njcn.energy.pojo.po.EleCtrl;
import com.njcn.energy.pojo.po.EleEpdPqd;
import com.njcn.energy.service.IEleCtrlService;
import com.njcn.energy.service.IEleEpdPqdService;
import com.njcn.web.controller.BaseController;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiOperation;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.*;

/**
 * 类的介绍：
 *
 * @author xuyang
 * @version 1.0.0
 * @createTime 2022/3/15 20:02
 */
@Slf4j
@RestController
@RequestMapping("/ctrl")
@RequiredArgsConstructor
@Api(tags = "设备控制数据管理")
public class EleCtrlController extends BaseController {

    private final IEleCtrlService eleCtrlService;

    @PostMapping("/add")
    @OperateInfo(info = LogEnum.SYSTEM_COMMON)
    @ApiOperation("新增设备控制数据")
    @ApiImplicitParam(name = "eleCtrl", value = "设备控制数据", required = true)
    public HttpResult<Boolean> add(@RequestBody EleCtrl eleCtrl){
        String methodDescribe = getMethodDescribe("add");
        LogUtil.njcnDebug(log, "{}，设备控制数据：{}", methodDescribe, eleCtrl);
        boolean result = eleCtrlService.addCtrl(eleCtrl);
        return HttpResultUtil.assembleCommonResponseResult(CommonResponseEnum.SUCCESS, result, methodDescribe);

    }

    @PutMapping("/update")
    @OperateInfo(info = LogEnum.SYSTEM_COMMON)
    @ApiOperation("修改设备控制数据")
    @ApiImplicitParam(name = "eleCtrl", value = "设备控制数据", required = true)
    public HttpResult<Boolean> update(@RequestBody EleCtrl eleCtrl){
        String methodDescribe = getMethodDescribe("update");
        LogUtil.njcnDebug(log, "{}，设备控制数据：{}", methodDescribe, eleCtrl);
        boolean result = eleCtrlService.updateCtrl(eleCtrl);
        return HttpResultUtil.assembleCommonResponseResult(CommonResponseEnum.SUCCESS, result, methodDescribe);
    }

    @GetMapping("/findByName")
    @OperateInfo(info = LogEnum.SYSTEM_COMMON)
    @ApiOperation("根据名称查找数据")
    @ApiImplicitParam(name = "name", value = "名称", required = true)
    public HttpResult<EleCtrl> findByName(@RequestParam String name){
        String methodDescribe = getMethodDescribe("findByName");
        LogUtil.njcnDebug(log, "{}，名称为：{}", methodDescribe, name);
        EleCtrl eleCtrl = eleCtrlService.findByName(name);
        return HttpResultUtil.assembleCommonResponseResult(CommonResponseEnum.SUCCESS, eleCtrl, methodDescribe);
    }

}
